#include "CommandTrigger.h"

CommandTrigger::CommandTrigger(void)
{
	clearCommand();

	return;
}

CommandTrigger::~CommandTrigger(void)
{
	clearCommand();
}

void CommandTrigger::clearCommand(void)
{
	reset();
	limitTime = 0;
	commandArray.clear();

	return;
}

void CommandTrigger::reset(void)
{
	regTime = chargeTime = 0;
	phase = -1;
	index = 0;

	return;
}

void CommandTrigger::setLimit(unsigned long msec)
{
	limitTime = msec;

	return;
}

void CommandTrigger::pushCommand(int phase, int button, fkut_SwitchStatus state)
{
	CommandElem elem;

	elem.phase = phase;
	elem.button = button;
	elem.state = state;
	commandArray.push_back(elem);

	return;
}

bool CommandTrigger::check(EventManager *argEvent)
{
	// z̉Ԗڂ̗vfĂ̂
	// o̒l͂炸ɁÅ֐ł炵Ă
	int	tmpIndex = index;
	fkut_SwitchStatus	sw;

	// ܂͂JnĂȂꍇ́AԌv̊_𖈉XV
	// ͂n܂Ăꍇ́Aԓ𔻒肵A߂Ă烊Zbg
	if(phase == -1) {
		regTime = fk_Window::getNow();
	} else if(fk_Window::getNow() - regTime > limitTime){
		reset();
		return false;
	}

	// phase̔ȂAJԂĂ܂Ƃ߂Ĕ肷
	do {
		// 100𒴂ĂL[ƂāAȊO̓{^ƂĔ
		if(commandArray[tmpIndex].button > 100) {
			sw = argEvent->getJoyDirectionStatus(0, commandArray[tmpIndex].button-100);
		} else {
			sw = argEvent->getJoyButtonStatus(0, commandArray[tmpIndex].button);
		}

		// 肵ĂR}hvfĂ邩H
		if(sw == commandArray[tmpIndex].state) {
			// ̗vfɔi߂
			tmpIndex++;
			// Ō܂Ŕ肵ĂR}hƂtrueԂ
			if(tmpIndex == (int)commandArray.size()) {
				reset();
				return true;
			}
		} else {
			return false;
		}
	} while(commandArray[tmpIndex].phase == phase+1);
	// phaseɐi
	phase++;
	index = tmpIndex;
	// pȂ̂falseԂ
	return false;
}
