#pragma once
#include "FKUT/TrackBall.h"
#include "FKUT/OBB.h"
#include "SceneBase.h"
#include "FieldMap.h"
#include "Player.h"
#include "FKUT/SpriteModel.h"

class SceneOBB : public SceneBase {
private:
	fk_Model		lightModel;
	fk_Light		light;

	Player			player;
	FieldMap		map;

	fk_TrackBall	tb;

	fkut_SpriteModel	spr;

	void readTest(void);
	void writeTest(void);

public:
	SceneOBB(fk_Window *, EventManager *);
	~SceneOBB(void);

	// V[vZXs
	int	onPeriod(void);
};
